<script setup lang="ts">
  import { getSessionContext } from '@shopware-pwa/api-client';
  import { SessionContext } from '@shopware-pwa/types';
  import { v4 as uuidv4 } from 'uuid';
  import { getPrefix, getDefaultLocale } from './i18n/src/helpers/prefix';
  import { COOKIE_LIFESPAN, COOKIE_PATH } from '@/helpers/constants';
  import '~/main.css';

  const APP_LOADING_CONFIG_DEFAULT = {
    mainClass: 'bg-white',
  };

  const contextToken = useCookie('sw-context-token', {
    maxAge: COOKIE_LIFESPAN,
    sameSite: 'lax',
    path: COOKIE_PATH,
  });

  // Generate a random UUID
  const randomUUID = uuidv4();

  const appId = useSessionStorage<string | null>('appId', randomUUID);

  const nuxtApp = useNuxtApp();
  /**
   * Init breadcrumbs context
   */
  useBreadcrumbs();

  useHead({
    title: 'Digital Sales Rooms',
    meta: [{ name: 'description', content: 'by Shopware' }],
    htmlAttrs: {
      lang: 'en',
    },
  });
  const { apiInstance } = useShopwareContext();
  const { data: sessionContextData } = await useAsyncData('sessionContext', async () => {
    return await getSessionContext(apiInstance);
  });
  useSessionContext(sessionContextData.value as SessionContext);

  useNotifications();
  const { shopPageModalController } = useShopPage();
  const { refreshUser } = useUser();
  const installed = ref(false);
  const isLoading = ref(false);
  const loadingConfig = ref<AppLoadingConfig>({});

  const { locale, availableLocales } = useI18n();
  const router = useRouter();
  const {
    getAvailableLanguages,
    getLanguageCodeFromId,
    getLanguageIdFromCode,
    changeLanguage,
    languages: storeLanguages,
  } = useInternationalization();

  nuxtApp.provide(
    'setLoading',
    (state: boolean, config: AppLoadingConfig = APP_LOADING_CONFIG_DEFAULT) => {
      loadingConfig.value = config;
      isLoading.value = state;
    },
  );

  nuxtApp.provide('contextToken', contextToken);
  nuxtApp.provide('appId', appId);

  const { sessionContext, languageIdChain, refreshSessionContext, setCurrency } =
    useSessionContext();

  const { data: languages } = await useAsyncData('languages', async () => {
    return await getAvailableLanguages();
  });

  // if (res.value) {
  //   loading.value = false;
  // }

  if (languages.value?.elements.length && router.currentRoute.value.name) {
    storeLanguages.value = languages.value?.elements;
    // Prefix from url
    const prefix = getPrefix(availableLocales, router.currentRoute.value.name as string);

    // Language set on the backend side
    const sessionLanguage = getLanguageCodeFromId(languageIdChain.value);

    // If languages are not the same, set one from prefix
    if (sessionLanguage !== prefix || sessionLanguage !== getDefaultLocale()) {
      await changeLanguage(getLanguageIdFromCode(prefix || getDefaultLocale()));
      await refreshSessionContext();
    }

    locale.value = prefix || getDefaultLocale();
    // Set prefix from CMS components
    provide('urlPrefix', prefix);
  }

  const updateDomainPrice = async () => {
    // set price
    const prefix = getPrefix(availableLocales, router.currentRoute.value.name as string);
    const currentUrl = !prefix ? window.location.origin : `${window.location.origin}/${prefix}`;
    const currentSaleChannelDomain = sessionContext.value?.salesChannel.domains.find((domain) => {
      return domain.url === currentUrl;
    });
    if (currentSaleChannelDomain) {
      await setCurrency({ id: currentSaleChannelDomain?.currencyId });
      await refreshSessionContext();
    }
  };

  onBeforeMount(async () => {
    try {
      await updateDomainPrice();
      await prefetchData();
    } finally {
      installed.value = true;
    }
  });

  const prefetchData = async () => {
    await refreshUser();
  };
</script>

<template>
  <SwLoadingScreen v-if="!installed || isLoading" :config="loadingConfig" />
  <NuxtLayout v-if="installed">
    <NuxtLoadingIndicator />
    <NuxtPage />
    <SwToasts />
    <SwModals />
    <ShopPageModal
      v-if="shopPageModalController.isOpen.value"
      :controller="shopPageModalController"
    />
  </NuxtLayout>
</template>
